:- nl & write('Loading Android permissions system...') & nl & nl &
   type_check &
   reset_types &
   add_lib('setloglib_tc.slog') &
   consult('types.pl') &
   add_lib('cons.pl') &
   add_lib('estado.pl') &
   add_lib('runtimePermissions.pl') & 
   add_lib('update.pl') &
   add_lib('implementacion.pl') &
   add_lib('semantica.pl').

:- dec_p_type(lInstallPO).
lInstallPO :-
  consult('install.pl',app) &
  nl & nl & write('Run check_install') & nl & nl.

:- dec_p_type(lUninstallPO).
lUninstallPO :-
  consult('uninstall.pl',app) &
  nl & nl & write('Run check_uninstall') & nl & nl.

:- dec_p_type(lGrantPO).
lGrantPO :-
  consult('grant.pl',app) &
  nl & nl & write('Run check_grant') & nl & nl.

:- dec_p_type(lGrantAutoPO).
lGrantAutoPO :-
  consult('grantAuto.pl',app) &
  nl & nl & write('Run check_grantAuto') & nl & nl.

:- dec_p_type(lRevokePO).
lRevokePO :-
  consult('revoke.pl',app) &
  nl & nl & write('Run check_revoke') & nl & nl.

:- dec_p_type(lRevokeGroupPO).
lRevokeGroupPO :-
  consult('revokeGroup.pl',app) &
  nl & nl & write('Run check_revokeGroup') & nl & nl.

:- dec_p_type(lReadPO).
lReadPO :-
  consult('read.pl',app) &
  nl & nl & write('Run check_read') & nl & nl.

:- dec_p_type(lWritePO).
lWritePO :-
  consult('write.pl',app) &
  nl & nl & write('Run check_write') & nl & nl.

:- dec_p_type(lStartActivityPO).
lStartActivityPO :-
  consult('startActivity.pl',app) &
  nl & nl & write('Run check_startActivity') & nl & nl.

:- dec_p_type(lStartActivityForResultPO).
lStartActivityForResultPO :-
  consult('startActivityForResult.pl',app) &
  nl & nl & write('Run check_startActivityForResult') & nl & nl.

:- dec_p_type(lStartServicePO).
lStartServicePO :-
  consult('startService.pl',app) &
  nl & nl & write('Run check_startService') & nl & nl.

:- dec_p_type(lSendBroadcastPO).
lSendBroadcastPO :-
  consult('sendBroadcast.pl',app) &
  nl & nl & write('Run check_sendBroadcast') & nl & nl.

:- dec_p_type(lSendOrderedBroadcastPO).
lSendOrderedBroadcastPO :-
  consult('sendOrderedBroadcast.pl',app) &
  nl & nl & write('Run check_sendOrderedBroadcast') & nl & nl.

:- dec_p_type(lSendStickyBroadcastPO).
lSendStickyBroadcastPO :-
  consult('sendStickyBroadcast.pl',app) &
  nl & nl & write('Run check_sendStickyBroadcast') & nl & nl.

:- dec_p_type(lResolveIntentPO).
lResolveIntentPO :-
  consult('resolveIntent.pl',app) &
  nl & nl & write('Run check_resolveIntent') & nl & nl.

:- dec_p_type(lReceiveIntentPO).
lReceiveIntentPO :-
  consult('receiveIntent.pl',app) &
  nl & nl & write('Run check_receiveIntent') & nl & nl.

:- dec_p_type(lStopPO).
lStopPO :-
  consult('stop.pl',app) &
  nl & nl & write('Run check_stop') & nl & nl.

:- dec_p_type(lGrantPPO).
lGrantPPO :-
  consult('grantp.pl',app) &
  nl & nl & write('Run check_grantp') & nl & nl.

:- dec_p_type(lRevokeDelPO).
lRevokeDelPO :-
  consult('revokeDel.pl',app) &
  nl & nl & write('Run check_revokeDel') & nl & nl.

:- dec_p_type(lVerifyOldAppPO).
lVerifyOldAppPO :-
  consult('verifyOldApp.pl',app) &
  nl & nl & write('Run check_verifyOldApp') & nl & nl.

:- dec_p_type(lCallPO).
lCallPO :-
  consult('call.pl',app) &
  nl & nl & write('Run check_call') & nl & nl.

:- dec_p_type(lProperties).
lProperties :-
  consult('modelProperties.pl',app) &
  nl & nl & write('Run check_prop') & nl & nl.

:- dec_p_type(lRevokeAndNotGrant).
lRevokeAndNotGrant :-
  consult('revokeAndNotGrant.pl',app) &
  nl & nl & write('Run check_revokeAndNotGrant') & nl & nl.

:- dec_p_type(lIfOldAppRunThenVerified).
lIfOldAppRunThenVerified :-
  consult('ifOldAppRunThenVerified.pl',app) &
  nl & nl & write('Run check_ifOldAppRunThenVerified') & nl & nl.

:- dec_p_type(check_all).
check_all :-
  check_install &
  check_uninstall &
  check_grant &
  check_grantAuto &
  check_revoke &
  check_revokeGroup &
  check_read &
  check_write &
  check_startActivity &
  check_startActivityForResult &
  check_startService &
  check_sendBroadcast &
  check_sendOrderedBroadcast &
  check_sendStickyBroadcast &
  check_resolveIntent &
  check_receiveIntent &
  check_stop &
  check_grantp &
  check_revokeDel &
  check_verifyOldApp &
  check_call &
  check_prop.

:- dec_p_type(lAllPO).
lAllPO :-
  lInstallPO &
  lUninstallPO &
  lGrantPO &
  lGrantAutoPO &
  lRevokePO &
  lRevokeGroupPO &
  lReadPO &
  lWritePO &
  lStartActivityPO &
  lStartActivityForResultPO &
  lStartServicePO &
  lSendBroadcastPO &
  lSendOrderedBroadcastPO &
  lSendStickyBroadcastPO &
  lResolveIntentPO &
  lReceiveIntentPO &
  lStopPO &
  lGrantPPO &
  lRevokeDelPO &
  lCallPO &
  lVerifyOldAppPO &
  lProperties &
  lRevokeAndNotGrant &
  lIfOldAppRunThenVerified &
  nl & nl & write('Run check_all') & nl & nl.

:- dec_p_type(writedone).
writedone :-
  prolog_call(ansi_format([bold,fg(green)],'done',[])).

