% system

:- dec_p_type(state(system,state)).
state(Sy,St) :-
  Sy = [St,_2]! &
    dec(_2,environment).

:- dec_p_type(environment(system,environment)).
environment(Sy,E) :-
  Sy = [_1,E]! &
    dec(_1,state).


% state

:- dec_p_type(apps(state,set(idApp))).
apps(S,SA) :-
  S = [SA,_2,_3,_4,_5,_6,_7,_8,_9]! &
    dec(_2,set(idApp)) &
    dec(_3,rel(idApp,set(idGrp))) &
    dec(_4,rel(idApp,set(perm))) &
    dec(_5,rel(iCmp,cmp)) &
    dec(_6,rel([idApp,cProvider,uri],pType)) &
    dec(_7,rel([iCmp,cProvider,uri],pType)) &
    dec(_8,rel([idApp,res],val)) &
    dec(_9,set([iCmp,intent])).

:- dec_p_type(resCont(state,rel([idApp,res],val))).
resCont(S,RC) :-
  S = [_1,_2,_3,_4,_5,_6,_7,RC,_9]! &
    dec(_1,set(idApp)) &
    dec(_2,set(idApp)) &
    dec(_3,rel(idApp,set(idGrp))) &
    dec(_4,rel(idApp,set(perm))) &
    dec(_5,rel(iCmp,cmp)) &
    dec(_6,rel([idApp,cProvider,uri],pType)) &
    dec(_7,rel([iCmp,cProvider,uri],pType)) &
    dec(_9,set([iCmp,intent])).

:- dec_p_type(perms(state,rel(idApp,set(perm)))).
perms(S,P) :-
  S = [_1,_2,_3,P,_5,_6,_7,_8,_9]! &
    dec(_1,set(idApp)) &
    dec(_2,set(idApp)) &
    dec(_3,rel(idApp,set(idGrp))) &
    dec(_5,rel(iCmp,cmp)) &
    dec(_6,rel([idApp,cProvider,uri],pType)) &
    dec(_7,rel([iCmp,cProvider,uri],pType)) &
    dec(_8,rel([idApp,res],val)) &
    dec(_9,set([iCmp,intent])).

:- dec_p_type(grantedPermGroups(state,rel(idApp,set(idGrp)))).
grantedPermGroups(S,G) :-
  S = [_1,_2,G,_4,_5,_6,_7,_8,_9]! &
    dec(_1,set(idApp)) &
    dec(_2,set(idApp)) &
    dec(_4,rel(idApp,set(perm))) &
    dec(_5,rel(iCmp,cmp)) &
    dec(_6,rel([idApp,cProvider,uri],pType)) &
    dec(_7,rel([iCmp,cProvider,uri],pType)) &
    dec(_8,rel([idApp,res],val)) &
    dec(_9,set([iCmp,intent])).

:- dec_p_type(delTPerms(state,rel([iCmp,cProvider,uri],pType))).
delTPerms(S,TP) :-
  S = [_1,_2,_3,_4,_5,_6,TP,_8,_9]! &
    dec(_1,set(idApp)) &
    dec(_2,set(idApp)) &
    dec(_3,rel(idApp,set(idGrp))) &
    dec(_4,rel(idApp,set(perm))) &
    dec(_5,rel(iCmp,cmp)) &
    dec(_6,rel([idApp,cProvider,uri],pType)) &
    dec(_8,rel([idApp,res],val)) &
    dec(_9,set([iCmp,intent])).

:- dec_p_type(running(state,rel(iCmp,cmp))).
running(S,R) :-
  S = [_1,_2,_3,_4,R,_6,_7,_8,_9]! &
    dec(_1,set(idApp)) &
    dec(_2,set(idApp)) &
    dec(_3,rel(idApp,set(idGrp))) &
    dec(_4,rel(idApp,set(perm))) &
    dec(_6,rel([idApp,cProvider,uri],pType)) &
    dec(_7,rel([iCmp,cProvider,uri],pType)) &
    dec(_8,rel([idApp,res],val)) &
    dec(_9,set([iCmp,intent])).

:- dec_p_type(sentIntents(state,set([iCmp,intent]))).
sentIntents(S,SI) :-
  S = [_1,_2,_3,_4,_5,_6,_7,_8,SI]! &
    dec(_1,set(idApp)) &
    dec(_2,set(idApp)) &
    dec(_3,rel(idApp,set(idGrp))) &
    dec(_4,rel(idApp,set(perm))) &
    dec(_5,rel(iCmp,cmp)) &
    dec(_6,rel([idApp,cProvider,uri],pType)) &
    dec(_7,rel([iCmp,cProvider,uri],pType)) &
    dec(_8,rel([idApp,res],val)).

:- dec_p_type(delPPerms(state,rel([idApp,cProvider,uri],pType))).
delPPerms(S,PP) :-
  S = [_1,_2,_3,_4,_5,PP,_7,_8,_9]! &
    dec(_1,set(idApp)) &
    dec(_2,set(idApp)) &
    dec(_3,rel(idApp,set(idGrp))) &
    dec(_4,rel(idApp,set(perm))) &
    dec(_5,rel(iCmp,cmp)) &
    dec(_7,rel([iCmp,cProvider,uri],pType)) &
    dec(_8,rel([idApp,res],val)) &
    dec(_9,set([iCmp,intent])).

:- dec_p_type(alreadyVerified(state,set(idApp))).
alreadyVerified(S,AV) :-
  S = [_1,AV,_3,_4,_5,_6,_7,_8,_9]! &
    dec(_1,set(idApp)) &
    dec(_2,set(idApp)) &
    dec(_3,rel(idApp,set(idGrp))) &
    dec(_4,rel(idApp,set(perm))) &
    dec(_5,rel(iCmp,cmp)) &
    dec(_6,rel([idApp,cProvider,uri],pType)) &
    dec(_7,rel([iCmp,cProvider,uri],pType)) &
    dec(_8,rel([idApp,res],val)) &
    dec(_9,set([iCmp,intent])).

% environment

:- dec_p_type(systemImage(environment,set(sysImgApp))).
systemImage(E,SS) :-
  E = [_1,_2,_3,SS]! &
    dec(_1,manifest_t) &
    dec(_2,rel(idApp,cert)) &
    dec(_3,rel(idApp,set(perm))).

:- dec_p_type(manifest(environment,manifest_t)).
manifest(E,M) :-
  E = [M,_2,_3,_4]! &
    dec(_2,rel(idApp,cert)) &
    dec(_3,rel(idApp,set(perm))) &
    dec(_4,set(sysImgApp)).

:- dec_p_type(defPerms(environment,rel(idApp,set(perm)))).
defPerms(E,P) :-
  E = [_1,_2,P,_4]! &
    dec(_1,manifest_t) &
    dec(_2,rel(idApp,cert)) &
    dec(_4,set(sysImgApp)).

:- dec_p_type(cert(environment,rel(idApp,cert))).
cert(E,CR) :-
  E = [_1,CR,_3,_4]! &
    dec(_1,manifest_t) &
    dec(_3,rel(idApp,set(perm))) &
    dec(_4,set(sysImgApp)).


% sysImgApp

:- dec_p_type(idSI(sysImgApp,idApp)).
idSI(S,A) :-
  S = [A,_2,_3,_4,_5]! &
    dec(_2,cert) &
    dec(_3,manifest) &
    dec(_4,set(perm)) &
    dec(_5,set(res)).

:- dec_p_type(n_idSI(sysImgApp,idApp)).
n_idSI(S,A) :-
  S = [_1,_2,_3,_4,_5]! &
  A neq _1 &
    dec(_1,idApp) &
    dec(_2,cert) &
    dec(_3,manifest) &
    dec(_4,set(perm)) &
    dec(_5,set(res)).

:- dec_p_type(manifestSI(sysImgApp,manifest)).
manifestSI(S,M) :-
  S = [_1,_2,M,_4,_5]! &
    dec(_1,idApp) &
    dec(_2,cert) &
    dec(_4,set(perm)) &
    dec(_5,set(res)).

:- dec_p_type(n_manifestSI(sysImgApp,manifest)).
n_manifestSI(S,M) :-
  S = [_1,_2,_3,_4,_5]! &
  M neq _3 &
    dec(_1,idApp) &
    dec(_2,cert) &
    dec(_3,manifest) &
    dec(_4,set(perm)) &
    dec(_5,set(res)).

:- dec_p_type(defPermsSI(sysImgApp,set(perm))).
defPermsSI(S,P) :-
  S = [_1,_2,_3,P,_5]! &
    dec(_1,idApp) &
    dec(_2,cert) &
    dec(_3,manifest) &
    dec(_5,set(res)).

:- dec_p_type(certSI(sysImgApp,cert)).
certSI(S,C) :-
  S = [_1,C,_3,_4,_5]! &
    dec(_1,idApp) &
    dec(_2,cert) &
    dec(_3,manifest) &
    dec(_4,set(perm)) &
    dec(_5,set(res)).

:- dec_p_type(n_certSI(sysImgApp,cert)).
n_certSI(S,C) :-
  S = [_1,_2,_3,_4,_5]! &
  C neq _2 &
    dec(_1,idApp) &
    dec(_2,cert) &
    dec(_3,manifest) &
    dec(_4,set(perm)) &
    dec(_5,set(res)).


% manifest

:- dec_p_type(cmp(manifest,set(cmp))).
cmp(M,SC) :-
  M = [SC,_2,_3,_4,_5,_6]! &
    dec(_2,optn) &
    dec(_3,optn) &
    dec(_4,set(perm)) &
    dec(_5,set(perm)) &
    dec(_6,optp).

:- dec_p_type(use(manifest,set(perm))).
use(M,SC) :-
  M = [_1,_2,_3,SC,_5,_6]! &
    dec(_1,set(cmp)) &
    dec(_2,optn) &
    dec(_3,optn) &
    dec(_5,set(perm)) &
    dec(_6,optp).

:- dec_p_type(usrP(manifest,set(perm))).
usrP(M,UP) :-
  M = [_1,_2,_3,_4,UP,_6]! &
    dec(_1,set(cmp)) &
    dec(_2,optn) &
    dec(_3,optn) &
    dec(_4,set(perm)) &
    dec(_6,optp).

:- dec_p_type(minSdk(manifest,optn)).
minSdk(M,S) :-
  M = [_1,S,_3,_4,_5,_6]! &
    dec(_1,set(cmp)) &
    dec(_3,optn) &
    dec(_4,set(perm)) &
    dec(_5,set(perm)) &
    dec(_6,optp).

:- dec_p_type(n_minSdk(manifest,optn)).
n_minSdk(M,S) :-
  M = [_1,_2,_3,_4,_5,_6]! &
    S neq _2 &
    dec(_1,set(cmp)) &
    dec(_2,optn) &
    dec(_3,optn) &
    dec(_4,set(perm)) &
    dec(_5,set(perm)) &
    dec(_6,optp).

:- dec_p_type(targetSdk(manifest,optn)).
targetSdk(M,S) :-
  M = [_1,_2,S,_4,_5,_6]! &
    dec(_1,set(cmp)) &
    dec(_2,optn) &
    dec(_4,set(perm)) &
    dec(_5,set(perm)) &
    dec(_6,optp).

:- dec_p_type(n_targetSdk(manifest,optn)).
n_targetSdk(M,S) :-
  M = [_1,_2,_3,_4,_5,_6]! &
    S neq _3 &
    dec(_1,set(cmp)) &
    dec(_2,optn) &
    dec(_3,optn) &
    dec(_4,set(perm)) &
    dec(_5,set(perm)) &
    dec(_6,optp).

:- dec_p_type(appE(manifest,optp)).
appE(M,A) :-
  M = [_1,_2,_3,_4,_5,A]! &
    dec(_1,set(cmp)) &
    dec(_2,optn) &
    dec(_3,optn) &
    dec(_4,set(perm)) &
    dec(_5,set(perm)).


% cProvider

:- dec_p_type(map_res(cProvider,rel(uri,res))).
map_res(Cp,Mr) :-
  Cp = [_1,Mr,_3,_4,_5,_6,_7,_8]! &
    dec(_1,idCmp) &
    dec(_3,optb) &
    dec(_4,optp) &
    dec(_5,optp) &
    dec(_6,optp) &
    dec(_7,bool) &
    dec(_8,set(uri)).

:- dec_p_type(idC(cProvider,idCmp)).
idC(Cp,I) :-
  Cp = [I,_2,_3,_4,_5,_6,_7,_8]! &
    dec(_2,rel(uri,res)) &
    dec(_3,optb) &
    dec(_4,optp) &
    dec(_5,optp) &
    dec(_6,optp) &
    dec(_7,bool) &
    dec(_8,set(uri)).

:- dec_p_type(expC(cProvider,optb)).
expC(Cp,O) :-
  Cp = [_1,_2,O,_4,_5,_6,_7,_8]! &
    dec(_1,idCmp) &
    dec(_2,rel(uri,res)) &
    dec(_4,optp) &
    dec(_5,optp) &
    dec(_6,optp) &
    dec(_7,bool) &
    dec(_8,set(uri)).

:- dec_p_type(n_expC(cProvider,optb)).
n_expC(Cp,O) :-
  Cp = [_1,_2,_3,_4,_5,_6,_7,_8]! &
    O neq _3 &
    dec(_1,idCmp) &
    dec(_2,rel(uri,res)) &
    dec(_3,optb) &
    dec(_4,optp) &
    dec(_5,optp) &
    dec(_6,optp) &
    dec(_7,bool) &
    dec(_8,set(uri)).

:- dec_p_type(cmpEC(cProvider,optp)).
cmpEC(Cp,O) :-
  Cp = [_1,_2,_3,O,_5,_6,_7,_8]! &
    dec(_1,idCmp) &
    dec(_2,rel(uri,res)) &
    dec(_3,optb) &
    dec(_5,optp) &
    dec(_6,optp) &
    dec(_7,bool) &
    dec(_8,set(uri)).

:- dec_p_type(readE(cProvider,optp)).
readE(Cp,P) :-
  Cp = [_1,_2,_3,_4,P,_6,_7,_8]! &
    dec(_1,idCmp) &
    dec(_2,rel(uri,res)) &
    dec(_3,optb) &
    dec(_4,optp) &
    dec(_6,optp) &
    dec(_7,bool) &
    dec(_8,set(uri)).

:- dec_p_type(writeE(cProvider,optp)).
writeE(Cp,P) :-
  Cp = [_1,_2,_3,_4,_5,P,_7,_8]! &
    dec(_1,idCmp) &
    dec(_2,rel(uri,res)) &
    dec(_3,optb) &
    dec(_4,optp) &
    dec(_5,optp) &
    dec(_7,bool) &
    dec(_8,set(uri)).

:- dec_p_type(grantU(cProvider,bool)).
grantU(Cp,B) :-
  Cp = [_1,_2,_3,_4,_5,_6,B,_8]! &
    dec(_1,idCmp) &
    dec(_2,rel(uri,res)) &
    dec(_3,optb) &
    dec(_4,optp) &
    dec(_5,optp) &
    dec(_6,optp) &
    dec(_8,set(uri)).

:- dec_p_type(uriP(cProvider,set(uri))).
uriP(Cp,SU) :-
  Cp = [_1,_2,_3,_4,_5,_6,_7,SU]! &
    dec(_1,idCmp) &
    dec(_2,rel(uri,res)) &
    dec(_3,optb) &
    dec(_4,optp) &
    dec(_5,optp) &
    dec(_6,optp) &
    dec(_7,bool).


% activity

:- dec_p_type(idA(activity,idCmp)).
idA(A,I) :-
  A = [I,_2,_3,_4]! &
    dec(_2,optb) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).

:- dec_p_type(expA(activity,optb)).
expA(A,O) :-
  A = [_1,O,_3,_4]! &
    dec(_1,idCmp) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).

:- dec_p_type(n_expA(activity,optb)).
n_expA(A,O) :-
  A = [_1,_2,_3,_4]! &
    O neq _2 &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).

:- dec_p_type(cmpEA(activity,optp)).
cmpEA(A,P) :-
  A = [_1,_2,P,_4]! &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_4,set(intentFilter)).

:- dec_p_type(intFilterA(activity,set(intentFilter))).
intFilterA(A,F) :-
  A = [_1,_2,_3,F]! &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_3,optp).

:- dec_p_type(n_intFilterA(activity,set(intentFilter))).
n_intFilterA(A,F) :-
  A = [_1,_2,_3,_4]! &
    F neq _4 &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).


% service

:- dec_p_type(idS(service,idCmp)).
idS(S,I) :-
  S = [I,_2,_3,_4]! &
    dec(_2,optb) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).

:- dec_p_type(expS(service,optb)).
expS(S,B) :-
  S = [_1,B,_3,_4]! &
    dec(_1,idCmp) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).

:- dec_p_type(n_expS(service,optb)).
n_expS(S,B) :-
  S = [_1,_2,_3,_4]! &
    B neq _2 &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).

:- dec_p_type(cmpES(service,optp)).
cmpES(S,P) :-
  S = [_1,_2,P,_4]! &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_4,set(intentFilter)).

:- dec_p_type(intFilterS(service,set(intentFilter))).
intFilterS(S,F) :-
  S = [_1,_2,_3,F]! &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_3,optp).

:- dec_p_type(n_intFilterS(service,set(intentFilter))).
n_intFilterS(S,F) :-
  S = [_1,_2,_3,_4]! &
    F neq _4 &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).


% broadReceiver

:- dec_p_type(idB(broadReceiver,idCmp)).
idB(Br,I) :-
  Br = [I,_2,_3,_4]! &
    dec(_2,optb) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).

:- dec_p_type(expB(broadReceiver,optb)).
expB(Br,B) :-
  Br = [_1,B,_3,_4]! &
    dec(_1,idCmp) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).

:- dec_p_type(n_expB(broadReceiver,optb)).
n_expB(Br,B) :-
  Br = [_1,_2,_3,_4]! &
    B neq _2 &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).

:- dec_p_type(cmpEB(broadReceiver,optp)).
cmpEB(Br,P) :-
  Br = [_1,_2,P,_4]! &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_4,set(intentFilter)).

:- dec_p_type(intFilterB(broadReceiver,set(intentFilter))).
intFilterB(Br,F) :-
  Br = [_1,_2,_3,F]! &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_3,optp).

:- dec_p_type(n_intFilterB(broadReceiver,set(intentFilter))).
n_intFilterB(Br,F) :-
  Br = [_1,_2,_3,_4]! &
    F neq _4 &
    dec(_1,idCmp) &
    dec(_2,optb) &
    dec(_3,optp) &
    dec(_4,set(intentFilter)).


% intentFilter

:- dec_p_type(actFilter(intentFilter,set(intentAction))).
actFilter(F,A) :-
  F = [A,_2,_3]! &
    dec(_2,set(data)) &
    dec(_3,set(category)).

:- dec_p_type(dataFilter(intentFilter,set(data))).
dataFilter(F,D) :-
  F = [_1,D,_3]! &
    dec(_1,set(intentAction)) &
    dec(_3,set(category)).

:- dec_p_type(catFilter(intentFilter,set(category))).
catFilter(F,C) :-
  F = [_1,_2,C]! &
    dec(_1,set(intentAction)) &
    dec(_2,set(data)).


% perm

:- dec_p_type(pl(perm,permLevel)).
pl(P,PL) :-
  P = [_1,_2,PL]! &
    dec(_1,idPerm) &
    dec(_2,optg).

:- dec_p_type(n_pl(perm,permLevel)).
n_pl(P,PL) :-
  P = [_1,_2,_3]! &
  PL neq _3 &
    dec(_1,idPerm) &
    dec(_2,optg) &
    dec(_3,permLevel).

:- dec_p_type(maybeGrp(perm,optg)).
maybeGrp(P,G) :-
  P = [_1,G,_3]! &
    dec(_1,idPerm) &
    dec(_3,permLevel).

:- dec_p_type(idP(perm,idPerm)).
idP(P,IP) :-
  P = [IP,_2,_3]! &
    dec(_2,optg) &
    dec(_3,permLevel).

% intent

:- dec_p_type(idI(intent,idInt)).
idI(I,ID) :-
  I = [ID,_2,_3,_4,_5,_6,_7,_8,_9]! &
    dec(_2,opti) &
    dec(_3,intentType) &
    dec(_4,opta) &
    dec(_5,data) &
    dec(_6,set(category)) &
    dec(_7,opte) &
    dec(_8,optf) &
    dec(_9,optp).

:- dec_p_type(cmpName(intent,opti)).
cmpName(I,O) :-
  I = [_1,O,_3,_4,_5,_6,_7,_8,_9]! &
    dec(_1,idInt) &
    dec(_3,intentType) &
    dec(_4,opta) &
    dec(_5,data) &
    dec(_6,set(category)) &
    dec(_7,opte) &
    dec(_8,optf) &
    dec(_9,optp).

:- dec_p_type(intType(intent,intentType)).
intType(I,IT) :-
  I = [_1,_2,IT,_4,_5,_6,_7,_8,_9]! &
    dec(_1,idInt) &
    dec(_2,opti) &
    dec(_4,opta) &
    dec(_5,data) &
    dec(_6,set(category)) &
    dec(_7,opte) &
    dec(_8,optf) &
    dec(_9,optp).

:- dec_p_type(action(intent,opta)).
action(I,A) :-
  I = [_1,_2,_3,A,_5,_6,_7,_8,_9]! &
    dec(_1,idInt) &
    dec(_2,opti) &
    dec(_3,intentType) &
    dec(_5,data) &
    dec(_6,set(category)) &
    dec(_7,opte) &
    dec(_8,optf) &
    dec(_9,optp).

:- dec_p_type(data(intent,data)).
data(I,D) :-
  I = [_1,_2,_3,_4,D,_6,_7,_8,_9]! &
    dec(_1,idInt) &
    dec(_2,opti) &
    dec(_3,intentType) &
    dec(_4,opta) &
    dec(_6,set(category)) &
    dec(_7,opte) &
    dec(_8,optf) &
    dec(_9,optp).

:- dec_p_type(category(intent,set(category))).
category(I,SC) :-
  I = [_1,_2,_3,_4,_5,SC,_7,_8,_9]! &
    dec(_1,idInt) &
    dec(_2,opti) &
    dec(_3,intentType) &
    dec(_4,opta) &
    dec(_5,data) &
    dec(_7,opte) &
    dec(_8,optf) &
    dec(_9,optp).

:- dec_p_type(extra(intent,opte)).
extra(I,E) :-
  I = [_1,_2,_3,_4,_5,_6,E,_8,_9]! &
    dec(_1,idInt) &
    dec(_2,opti) &
    dec(_3,intentType) &
    dec(_4,opta) &
    dec(_5,data) &
    dec(_6,set(category)) &
    dec(_8,optf) &
    dec(_9,optp).

:- dec_p_type(flags(intent,optf)).
flags(I,F) :-
  I = [_1,_2,_3,_4,_5,_6,_7,F,_9]! &
    dec(_1,idInt) &
    dec(_2,opti) &
    dec(_3,intentType) &
    dec(_4,opta) &
    dec(_5,data) &
    dec(_6,set(category)) &
    dec(_7,opte) &
    dec(_9,optp).

:- dec_p_type(brperm(intent,optp)).
brperm(I,P) :-
  I = [_1,_2,_3,_4,_5,_6,_7,_8,P]! &
    dec(_1,idInt) &
    dec(_2,opti) &
    dec(_3,intentType) &
    dec(_4,opta) &
    dec(_5,data) &
    dec(_6,set(category)) &
    dec(_7,opte) &
    dec(_8,optf).


% data

:- dec_p_type(path(data,optu)).
path(D,U) :-
  D = [U,_2,_3]! &
    dec(_2,optm) &
    dec(_3,dataType).

:- dec_p_type(mime(data,optm)).
mime(D,M) :-
  D = [_1,M,_3]! &
    dec(_1,optu) &
    dec(_3,dataType).

:- dec_p_type(type(data,dataType)).
type(D,T) :-
  D = [_1,_2,T]! &
    dec(_1,optu) &
    dec(_2,optm).
         

