:- dec_p_type(isAppInstalled(idApp,system)).
isAppInstalled(A,S) :-
  state(S,St) & dec(St,state) &
  apps(St,SA) & dec(SA,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &
  (A in SA
   or
   exists(Sysapp in SS,[B],dec(B,idApp) & dec(Sysapp,sysImgApp) & 
     A = B, 
     idSI(Sysapp,B)
   )
  ).

:- dec_p_type(n_isAppInstalled(idApp,system)).
n_isAppInstalled(A,S) :-
  state(S,St) & dec(St,state) &
  apps(St,SA) & dec(SA,set(idApp)) &
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  (A in SA
   or
   exists(Sysapp in SS,[B], 
     dec(B,idApp) & dec(Sysapp,sysImgApp) & 
     A = B, 
     idSI(Sysapp,B)
   )
  )).

:- dec_p_type(inApp(cmp,idApp,system)).
inApp(C,A,S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  (exists([X,M] in MM, [SC1],
     X = A & C in SC1 & dec(X,idApp) & dec(M,manifest), 
     cmp(M,SC1) & dec(SC1,set(cmp))
   )
   or
   exists(S1 in SS,[B,N,SC2],dec(S1,sysImgApp) & 
     A = B & C in SC2,
     idSI(S1,B) & manifestSI(S1,N) & cmp(N,SC2) & 
       dec(B,idApp) & dec(N,manifest) & dec(SC2,set(cmp))
   )
  ).

:- dec_p_type(isCProvider(cmp)).
isCProvider(C) :-
  dec(_C,cProvider) &
  cmpCP(_C) = C.

:- dec_p_type(n_isCProvider(cmp)).
n_isCProvider(C) :- 
  dec(_C1,activity) &
  cmpAct(_C1) = C
  or
  dec(_C2,service) &
  cmpSrv(_C2) = C
  or
  dec(_C3,broadReceiver) &
  cmpBR(_C3) = C.

:- dec_p_type(existsRes(cProvider,uri,system)).
existsRes(Cp,U,S) :-
  environment(S,E) & dec(E,environment) &
  state(S,St) & dec(St,state) &
  manifest(E,MM) & dec(MM,manifest_t) &
  resCont(St,RC) & dec(RC,rel([idApp,res],val)) &
  map_res(Cp,Mr) & dec(Mr,rel(uri,res)) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  (exists([A,M] in MM,[SC1],dec(A,idApp) & dec(M,manifest) &
     cmpCP(Cp) in SC1 &
     exists([U1,R1] in Mr,dec(U1,uri) & dec(R1,res) & 
       U = U1 & ncomp({[[A,R1],[A,R1]]},RC,{})
     ),
     cmp(M,SC1) & dec(SC1,set(cmp))
   )
   or
   exists(S1 in SS,[B,N,SC2],dec(S1,sysImgApp) &
     cmpCP(Cp) in SC2 &
     exists([U2,R2] in Mr,dec(U2,uri) & dec(R2,res) & 
       U = U2 & ncomp({[[B,R2],[B,R2]]},RC,{})
     ),
     idSI(S1,B) & manifestSI(S1,N) & cmp(N,SC2) & 
       dec(B,idApp) & dec(N,manifest) & dec(SC2,set(cmp))
   )
  ).

:- dec_p_type(getCmpId(cmp,idCmp)).
getCmpId(C,I) :-
  dec(A,activity) &
  C = cmpAct(A) & idA(A,I)
  or
  dec(S,service) &
  C = cmpSrv(S) & idS(S,I)
  or
  dec(Br,broadReceiver) &
  C = cmpBR(Br) & idB(Br,I)
  or
  dec(Cp,cProvider) &
  C = cmpCP(Cp) & idC(Cp,I).

% Parameter isSystemPerm : Perm -> Prop.
% Is introduced as an argument in the predicates that need it

:- dec_p_type(usrDefPerm(perm,system)).
usrDefPerm(P,S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &
  (exists([A,L] in DP, dec(A,idApp) & dec(L,set(perm)) & P in L)
   or
   exists(B in SS,[SP],dec(B,sysImgApp) & 
     P in SP, 
     dec(SP,set(perm)) & defPermsSI(B,SP)
   )
  ).

:- dec_p_type(n_usrDefPerm(perm,system)).
n_usrDefPerm(P,S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  neg(
    (exists([A,L] in DP, dec(A,idApp) & dec(L,set(perm)) & P in L)
     or
     exists(B in SS,[SP],dec(B,sysImgApp) & 
       P in SP, 
       dec(SP,set(perm)) & defPermsSI(B,SP)
     )
    )
  ).

:- dec_p_type(permExists(set(perm),perm,system)).
permExists(SystemPerm,P,S) :-
  P in SystemPerm
  or
  usrDefPerm(P,S).

:- dec_p_type(n_permExists(set(perm),perm,system)).
n_permExists(SystemPerm,P,S) :-
  neg(
    P in SystemPerm
    or
    usrDefPerm(P,S)
  ).

:- dec_p_type(allCmpDifferent1(system)).
allCmpDifferent1(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &

  foreach([A,M] in MM,[SC],dec(A,idApp) & dec(M,manifest) & 
    foreach([C1 in SC, C2 in SC],[I1,I2],dec([C1,C2],cmp) & 
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec(SC,set(cmp)) & cmp(M,SC)
  ).

:- dec_p_type(n_allCmpDifferent1(system)).
n_allCmpDifferent1(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &

neg(
  foreach([A,M] in MM,[SC],dec(A,idApp) & dec(M,manifest) & 
    foreach([C1 in SC, C2 in SC],[I1,I2],dec([C1,C2],cmp) & 
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec(SC,set(cmp)) & cmp(M,SC)
  )).

:- dec_p_type(allCmpDifferent2(system)).
allCmpDifferent2(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &

  foreach([[A1,M1] in MM,[A2,M2] in MM],[SC1,SC2],
      dec([A1,A2],idApp) & dec([M1,M2],manifest) &
    foreach([C1 in SC1, C2 in SC2],[I1,I2],dec([C1,C2],cmp) &
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec([SC1,SC2],set(cmp)) & cmp(M1,SC1) & cmp(M2,SC2)
  ).

:- dec_p_type(n_allCmpDifferent2(system)).
n_allCmpDifferent2(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &

neg(
  foreach([[A1,M1] in MM,[A2,M2] in MM],[SC1,SC2],
      dec([A1,A2],idApp) & dec([M1,M2],manifest) &
    foreach([C1 in SC1, C2 in SC2],[I1,I2],dec([C1,C2],cmp) &
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec([SC1,SC2],set(cmp)) & cmp(M1,SC1) & cmp(M2,SC2)
  )).


:- dec_p_type(allCmpDifferent3(system)).
allCmpDifferent3(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach(A in SS,[N,SC],dec(A,sysImgApp) & 
    foreach([C1 in SC, C2 in SC],[I1,I2],dec([C1,C2],cmp) &
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec(N,manifest) & dec(SC,set(cmp)) & manifestSI(A,N) & cmp(N,SC)
  ).

:- dec_p_type(n_allCmpDifferent3(system)).
n_allCmpDifferent3(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach(A in SS,[N,SC],dec(A,sysImgApp) & 
    foreach([C1 in SC, C2 in SC],[I1,I2],dec([C1,C2],cmp) &
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec(N,manifest) & dec(SC,set(cmp)) & manifestSI(A,N) & cmp(N,SC)
  )).

:- dec_p_type(allCmpDifferent4(system)).
allCmpDifferent4(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([A1 in SS,A2 in SS],[N1,SC1,N2,SC2],dec([A1,A2],sysImgApp) & 
    foreach([C1 in SC1, C2 in SC2],[I1,I2],dec([C1,C2],cmp) &
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec([N1,N2],manifest) & dec([SC1,SC2],set(cmp)) & 
    manifestSI(A1,N1) & cmp(N1,SC1) & manifestSI(A2,N2) & cmp(N2,SC2)
  ).

:- dec_p_type(n_allCmpDifferent4(system)).
n_allCmpDifferent4(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([A1 in SS,A2 in SS],[N1,SC1,N2,SC2],dec([A1,A2],sysImgApp) & 
    foreach([C1 in SC1, C2 in SC2],[I1,I2],dec([C1,C2],cmp) &
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec([N1,N2],manifest) & dec([SC1,SC2],set(cmp)) & 
    manifestSI(A1,N1) & cmp(N1,SC1) & manifestSI(A2,N2) & cmp(N2,SC2)
  )).

:- dec_p_type(allCmpDifferent5(system)).
allCmpDifferent5(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([[A1,M] in MM, A2 in SS],[SC1,N,SC2],
      dec(A1,idApp) & dec(A2,sysImgApp) & dec(M,manifest) &
    foreach([C1 in SC1, C2 in SC2],[I1,I2],dec([C1,C2],cmp) &
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec(N,manifest) & dec([SC1,SC2],set(cmp)) & 
    cmp(M,SC1) & manifestSI(A2,N) & cmp(N,SC2)
  ).

:- dec_p_type(n_allCmpDifferent5(system)).
n_allCmpDifferent5(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([[A1,M] in MM, A2 in SS],[SC1,N,SC2],
      dec(A1,idApp) & dec(A2,sysImgApp) & dec(M,manifest) &
    foreach([C1 in SC1, C2 in SC2],[I1,I2],dec([C1,C2],cmp) &
      (I1 = I2 implies C1 = C2),
      dec([I1,I2],idCmp) & getCmpId(C1,I1) & getCmpId(C2,I2)
    ),
    dec(N,manifest) & dec([SC1,SC2],set(cmp)) & 
    cmp(M,SC1) & manifestSI(A2,N) & cmp(N,SC2)
  )).

:- dec_p_type(notRepeatedCmps1(system)).
notRepeatedCmps1(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &

  foreach([[A1,M1] in MM,[A2,M2] in MM],[SC1,SC2],
      dec([A1,A2],idApp) & dec([M1,M2],manifest) &
    foreach([C1 in SC1, C2 in SC2],dec([C1,C2],cmp) & (C1 = C2 implies A1 = A2)),
    dec([SC1,SC2],set(cmp)) & cmp(M1,SC1) & cmp(M2,SC2)
  ).

:- dec_p_type(n_notRepeatedCmps1(system)).
n_notRepeatedCmps1(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &

neg(
  foreach([[A1,M1] in MM,[A2,M2] in MM],[SC1,SC2],
      dec([A1,A2],idApp) & dec([M1,M2],manifest) &
    foreach([C1 in SC1, C2 in SC2],dec([C1,C2],cmp) & (C1 = C2 implies A1 = A2)),
    dec([SC1,SC2],set(cmp)) & cmp(M1,SC1) & cmp(M2,SC2)
  )).

:- dec_p_type(notRepeatedCmps2(system)).
notRepeatedCmps2(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([A1 in SS, A2 in SS],[B1,N1,SC1,B2,N2,SC2],dec([A1,A2],sysImgApp) &
    foreach([C1 in SC1, C2 in SC2],dec([C1,C2],cmp) & (C1 = C2 implies B1 = B2)),
    dec([B1,B2],idApp) & dec([N1,N2],manifest) & dec([SC1,SC2],set(cmp)) &
    idSI(A1,B1) & manifestSI(A1,N1) & cmp(N1,SC1) & 
    idSI(A2,B2) & manifestSI(A2,N2) & cmp(N2,SC2)
  ).

:- dec_p_type(n_notRepeatedCmps2(system)).
n_notRepeatedCmps2(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([A1 in SS, A2 in SS],[B1,N1,SC1,B2,N2,SC2],dec([A1,A2],sysImgApp) &
    foreach([C1 in SC1, C2 in SC2],dec([C1,C2],cmp) & (C1 = C2 implies B1 = B2)),
    dec([B1,B2],idApp) & dec([N1,N2],manifest) & dec([SC1,SC2],set(cmp)) &
    idSI(A1,B1) & manifestSI(A1,N1) & cmp(N1,SC1) & 
    idSI(A2,B2) & manifestSI(A2,N2) & cmp(N2,SC2)
  )).

:- dec_p_type(notRepeatedCmps3(system)).
notRepeatedCmps3(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([[A1,M1] in MM,A2 in SS],[SC1,B2,N2,SC2],
      dec(A1,idApp) & dec(M1,manifest) & dec(A2,sysImgApp) &
    foreach([C1 in SC1, C2 in SC2],dec([C1,C2],cmp) & (C1 = C2 implies A1 = B2)),
    dec(N2,manifest) & dec(B2,idApp) & dec([SC1,SC2],set(cmp)) &
    cmp(M1,SC1) & idSI(A2,B2) & manifestSI(A2,N2) & cmp(N2,SC2)
  ).

:- dec_p_type(n_notRepeatedCmps3(system)).
n_notRepeatedCmps3(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([[A1,M1] in MM,A2 in SS],[SC1,B2,N2,SC2],
      dec(A1,idApp) & dec(M1,manifest) & dec(A2,sysImgApp) &
    foreach([C1 in SC1, C2 in SC2],dec([C1,C2],cmp) & (C1 = C2 implies A1 = B2)),
    dec(N2,manifest) & dec(B2,idApp) & dec([SC1,SC2],set(cmp)) &
    cmp(M1,SC1) & idSI(A2,B2) & manifestSI(A2,N2) & cmp(N2,SC2)
  )).

% delTmpRun uses cmpRunAppIns: whatever the image of IC in R is, 
% it's installed. makes (inApp c a s) unnecesary.
:- dec_p_type(delTmpRun(system)).
delTmpRun(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &
  delTPerms(St,TP) & dec(TP,rel([iCmp,cProvider,uri],pType)) &
  running(St,R) & dec(R,rel(iCmp,cmp)) &

  foreach([[IC,CP,U],PT] in TP,
    dec(IC,iCmp) & dec(CP,cProvider) & dec(U,uri) & dec(PT,pType) & 
    (exists([A1,M] in MM,[SC1],dec(A1,idApp) & dec(M,manifest) &
       cmpCP(CP) in SC1,
       dec(SC1,set(cmp)) & cmp(M,SC1)
     )
     or
     exists(A2 in SS,[SC2],dec(A2,sysImgApp) & 
       cmpCP(CP) in SC2,
       dec(SC2,set(cmp)) & dec(N,manifest) & manifestSI(A2,N) & cmp(N,SC2)
     )
    ) &
    ncomp({[IC,IC]},R,{})
  ).

:- dec_p_type(n_delTmpRun(system)).
n_delTmpRun(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &
  delTPerms(St,TP) & dec(TP,rel([iCmp,cProvider,uri],pType)) &
  running(St,R) & dec(R,rel(iCmp,cmp)) &

neg(
  foreach([[IC,CP,U],PT] in TP,
    dec(IC,iCmp) & dec(CP,cProvider) & dec(U,uri) & dec(PT,pType) & 
    (exists([A1,M] in MM,[SC1],dec(A1,idApp) & dec(M,manifest) &
       cmpCP(CP) in SC1,
       dec(SC1,set(cmp)) & cmp(M,SC1)
     )
     or
     exists(A2 in SS,[SC2],dec(A2,sysImgApp) & 
       cmpCP(CP) in SC2,
       dec(SC2,set(cmp)) & dec(N,manifest) & manifestSI(A2,N) & cmp(N,SC2)
     )
    ) &
    ncomp({[IC,IC]},R,{})
  )).

:- dec_p_type(notCPrunning(system)).
notCPrunning(S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  foreach([IC,C] in RR, dec(IC,iCmp) & dec(C,cmp) & neg(isCProvider(C))).

:- dec_p_type(n_notCPrunning(system)).
n_notCPrunning(S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  neg(
    foreach([IC,C] in RR, dec(IC,iCmp) & dec(C,cmp) & neg(isCProvider(C)))
  ).

:- dec_p_type(cmpRunAppIns(system)).
cmpRunAppIns(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([IC,C] in RR, dec(IC,iCmp) & dec(C,cmp) & 
    (exists([A,M] in MM,[SC1],dec(A,idApp) & dec(M,manifest) & 
       C in SC1,
       dec(SC1,set(cmp)) & cmp(M,SC1)
     )
     or
     exists(W in SS,[N,SC2],dec(W,sysImgApp) & 
       C in SC2,
       dec(N,manifest) & dec(SC2,set(cmp)) & manifestSI(W,N) & cmp(N,SC2)
     )
    ) 
  ).

:- dec_p_type(n_cmpRunAppIns(system)).
n_cmpRunAppIns(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &
  manifest(E,MM) & dec(MM,manifest_t) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([IC,C] in RR, dec(IC,iCmp) & dec(C,cmp) & 
    (exists([A,M] in MM,[SC1],dec(A,idApp) & dec(M,manifest) & 
       C in SC1,
       dec(SC1,set(cmp)) & cmp(M,SC1)
     )
     or
     exists(W in SS,[N,SC2],dec(W,sysImgApp) & 
       C in SC2,
       dec(N,manifest) & dec(SC2,set(cmp)) & manifestSI(W,N) & cmp(N,SC2)
     )
    ) 
  )).

:- dec_p_type(resContAppInst(system)).
resContAppInst(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  resCont(St,RC) & dec(RC,rel([idApp,res],val)) &
  apps(St,SA) & dec(SA,set(idApp)) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([[A,R],V] in RC,dec(A,idApp) & dec(R,res) & dec(V,val) &
    (A in SA
     or
     exists(W in SS,[B],dec(W,sysImgApp) & A = B, dec(B,idApp) & idSI(W,B))     
    )
  ).

:- dec_p_type(n_resContAppInst(system)).
n_resContAppInst(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  resCont(St,RC) & dec(RC,rel([idApp,res],val)) &
  apps(St,SA) & dec(SA,set(idApp)) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([[A,R],V] in RC,dec(A,idApp) & dec(R,res) & dec(V,val) &
    (A in SA
     or
     exists(W in SS,[B],dec(W,sysImgApp) & A = B, dec(B,idApp) & idSI(W,B))     
    )
  )).

:- dec_p_type(notDupPerm1(system)).
notDupPerm1(S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &

  foreach([[A1,SP1] in DP, [A2,SP2] in DP],
      dec([A1,A2],idApp) & dec([SP1,SP2],set(perm)) &
    foreach([P1 in SP1, P2 in SP2],[IP1,IP2],dec([P1,P2],perm) &
      (IP1 = IP2 implies P1 = P2 & A1 = A2),
      dec([IP1,IP2],idPerm) & idP(P1,IP1) & idP(P2,IP2)
    )
  ).

:- dec_p_type(n_notDupPerm1(system)).
n_notDupPerm1(S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &

neg(
  foreach([[A1,SP1] in DP, [A2,SP2] in DP],
      dec([A1,A2],idApp) & dec([SP1,SP2],set(perm)) &
    foreach([P1 in SP1, P2 in SP2],[IP1,IP2],dec([P1,P2],perm) &
      (IP1 = IP2 implies P1 = P2 & A1 = A2),
      dec([IP1,IP2],idPerm) & idP(P1,IP1) & idP(P2,IP2)
    )
  )).

:- dec_p_type(notDupPerm2(system)).
notDupPerm2(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([A1 in SS, A2 in SS],[ID1,ID2,SP1,SP2],dec([A1,A2],sysImgApp) &
    foreach([P1 in SP1, P2 in SP2],[IP1,IP2],dec([P1,P2],perm) &
      (IP1 = IP2 implies P1 = P2 & ID1 = ID2),
      dec([IP1,IP2],idPerm) & idP(P1,IP1) & idP(P2,IP2)
    ),
    dec([ID1,ID2],idApp) & idSI(A1,ID1) & idSI(A2,ID2) &
    dec([SP1,SP2],set(perm)) & defPermsSI(A1,SP1) & defPermsSI(A2,SP2)
  ).

:- dec_p_type(n_notDupPerm2(system)).
n_notDupPerm2(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([A1 in SS, A2 in SS],[ID1,ID2,SP1,SP2],dec([A1,A2],sysImgApp) &
    foreach([P1 in SP1, P2 in SP2],[IP1,IP2],dec([P1,P2],perm) &
      (IP1 = IP2 implies P1 = P2 & ID1 = ID2),
      dec([IP1,IP2],idPerm) & idP(P1,IP1) & idP(P2,IP2)
    ),
    dec([ID1,ID2],idApp) & idSI(A1,ID1) & idSI(A2,ID2) &
    dec([SP1,SP2],set(perm)) & defPermsSI(A1,SP1) & defPermsSI(A2,SP2)
  )).

:- dec_p_type(notDupPerm3(system)).
notDupPerm3(S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([[A1,SP1] in DP, A2 in SS],[ID2,SP2],
      dec(A1,idApp) & dec(SP1,set(perm)) & dec(A2,sysImgApp) &
    foreach([P1 in SP1, P2 in SP2],[IP1,IP2],dec([P1,P2],perm) &
      (IP1 = IP2 implies P1 = P2 & A1 = ID2),
      dec([IP1,IP2],idPerm) & idP(P1,IP1) & idP(P2,IP2)
    ),
    dec(ID2,idApp) & dec(SP2,set(perm)) & idSI(A2,ID2) & defPermsSI(A2,SP2)
  ).

:- dec_p_type(n_notDupPerm3(system)).
n_notDupPerm3(S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,DP) & dec(DP,rel(idApp,set(perm))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([[A1,SP1] in DP, A2 in SS],[ID2,SP2],
      dec(A1,idApp) & dec(SP1,set(perm)) & dec(A2,sysImgApp) &
    foreach([P1 in SP1, P2 in SP2],[IP1,IP2],dec([P1,P2],perm) &
      (IP1 = IP2 implies P1 = P2 & A1 = ID2),
      dec([IP1,IP2],idPerm) & idP(P1,IP1) & idP(P2,IP2)
    ),
    dec(ID2,idApp) & dec(SP2,set(perm)) & idSI(A2,ID2) & defPermsSI(A2,SP2)
  )).

:- dec_p_type(grantedPermsExist(set(perm),system)).
grantedPermsExist(SystemPerm,S) :-
  state(S,St) & dec(St,state) &
  perms(St,Perms) & dec(Perms,rel(idApp,set(perm))) &
  
  foreach([A,SP] in Perms,dec(A,idApp) & dec(SP,set(perm)) &
    foreach(P in SP,dec(P,perm) & permExists(SystemPerm,P,S))
  ).

:- dec_p_type(n_grantedPermsExist(set(perm),system)).
n_grantedPermsExist(SystemPerm,S) :-
  state(S,St) & dec(St,state) &
  perms(St,Perms) & dec(Perms,rel(idApp,set(perm))) &

neg(  
  foreach([A,SP] in Perms,dec(A,idApp) & dec(SP,set(perm)) &
    foreach(P in SP,dec(P,perm) & permExists(SystemPerm,P,S))
  )).

:- dec_p_type(statesConsistency1(system)).
statesConsistency1(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  manifest(E,MM) & dec(MM,manifest_t) &

  dompf(MM,Apps).

:- dec_p_type(n_statesConsistency1(system)).
n_statesConsistency1(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  manifest(E,MM) & dec(MM,manifest_t) &

  neg(dompf(MM,Apps)).

:- dec_p_type(statesConsistency2(system)).
statesConsistency2(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &

  dompf(CR,Apps).

:- dec_p_type(n_statesConsistency2(system)).
n_statesConsistency2(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &

  neg(dompf(CR,Apps)).

:- dec_p_type(statesConsistency3(system)).
statesConsistency3(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  defPerms(E,PR) & dec(PR,rel(idApp,set(perm))) &

  dompf(PR,Apps).

:- dec_p_type(n_statesConsistency3(system)).
n_statesConsistency3(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  defPerms(E,PR) & dec(PR,rel(idApp,set(perm))) &

  neg(dompf(PR,Apps)).

% in statesConsistency4* can't use eq. to dom due to systemImage
% dom doesn't support RIS
:- dec_p_type(statesConsistency41(system)).
statesConsistency41(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  perms(St,PR) & dec(PR,rel(idApp,set(perm))) &

  dompf(PR,DPR) & dec(DPR,set(idApp)) &
  subset(Apps,DPR).

:- dec_p_type(n_statesConsistency41(system)).
n_statesConsistency41(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  perms(St,PR) & dec(PR,rel(idApp,set(perm))) &

  dompf(PR,DPR) & dec(DPR,set(idApp)) &
  neg(subset(Apps,DPR)).

:- dec_p_type(statesConsistency42(system)).
statesConsistency42(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  perms(St,PR) & dec(PR,rel(idApp,set(perm))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  dompf(PR,DPR) & dec(DPR,set(idApp)) &
  foreach(SI in SS,[IA],dec(SI,sysImgApp) & 
    IA in DPR,
    dec(IA,idApp) & idSI(SI,IA)
  ).

:- dec_p_type(n_statesConsistency42(system)).
n_statesConsistency42(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  perms(St,PR) & dec(PR,rel(idApp,set(perm))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  dompf(PR,DPR) & dec(DPR,set(idApp)) &
neg(
  foreach(SI in SS,[IA],dec(SI,sysImgApp) & 
    IA in DPR,
    dec(IA,idApp) & idSI(SI,IA)
  )).


:- dec_p_type(statesConsistency43(system)).
statesConsistency43(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  perms(St,PR) & dec(PR,rel(idApp,set(perm))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([A1,P] in PR,dec(A1,idApp) & dec(P,set(perm)) &
    (A1 in Apps
     or
     exists(SI1 in SS,[IA1],dec(SI1,sysImgApp) & 
       IA1 = A1,dec(IA1,idApp) & idSI(SI1,IA1))
    )
  ).

:- dec_p_type(n_statesConsistency43(system)).
n_statesConsistency43(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  perms(St,PR) & dec(PR,rel(idApp,set(perm))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([A1,P] in PR,dec(A1,idApp) & dec(P,set(perm)) &
    (A1 in Apps
     or
     exists(SI1 in SS,[IA1],dec(SI1,sysImgApp) & 
       IA1 = A1,dec(IA1,idApp) & idSI(SI1,IA1))
    )
  )).


:- dec_p_type(statesConsistency51(system)).
statesConsistency51(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  grantedPermGroups(St,GR) & dec(GR,rel(idApp,set(idGrp))) &

  dompf(GR,DPR) & dec(DPR,set(idApp)) &
  subset(Apps,DPR).

:- dec_p_type(n_statesConsistency51(system)).
n_statesConsistency51(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  grantedPermGroups(St,GR) & dec(GR,rel(idApp,set(idGrp))) &

  dompf(GR,DPR) & dec(DPR,set(idApp)) &
  neg(subset(Apps,DPR)).

:- dec_p_type(statesConsistency52(system)).
statesConsistency52(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  grantedPermGroups(St,GR) & dec(GR,rel(idApp,set(idGrp))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  dompf(GR,DPR) & dec(DPR,set(idApp)) &
  foreach(SI in SS,[IA],dec(SI,sysImgApp) & 
    IA in DPR,
    dec(IA,idApp) & idSI(SI,IA)
  ).

:- dec_p_type(n_statesConsistency52(system)).
n_statesConsistency52(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  grantedPermGroups(St,GR) & dec(GR,rel(idApp,set(idGrp))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  dompf(GR,DPR) & dec(DPR,set(idApp)) &
neg(
  foreach(SI in SS,[IA],dec(SI,sysImgApp) & 
    IA in DPR,
    dec(IA,idApp) & idSI(SI,IA)
  )).


:- dec_p_type(statesConsistency53(system)).
statesConsistency53(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  grantedPermGroups(St,GR) & dec(GR,rel(idApp,set(idGrp))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([A1,P] in GR,dec(A1,idApp) & dec(P,set(idGrp)) &
    (A1 in Apps
     or
     exists(SI1 in SS,[IA1],dec(SI1,sysImgApp) & 
       IA1 = A1,dec(IA1,idApp) & idSI(SI1,IA1))
    )
  ).

:- dec_p_type(n_statesConsistency53(system)).
n_statesConsistency53(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  grantedPermGroups(St,GR) & dec(GR,rel(idApp,set(idGrp))) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([A1,P] in GR,dec(A1,idApp) & dec(P,set(idGrp)) &
    (A1 in Apps
     or
     exists(SI1 in SS,[IA1],dec(SI1,sysImgApp) & 
       IA1 = A1,dec(IA1,idApp) & idSI(SI1,IA1))
    )
  )).

:- dec_p_type(notDupApp(system)).
notDupApp(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach(A in SS,[ID],dec(A,sysImgApp) & ID nin Apps,dec(ID,idApp) & idSI(A,ID)).

:- dec_p_type(n_notDupApp(system)).
n_notDupApp(S) :-
  state(S,St) & dec(St,state) &
  environment(S,E) & dec(E,environment) &
  apps(St,Apps) & dec(Apps,set(idApp)) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach(A in SS,[ID],dec(A,sysImgApp) & ID nin Apps,dec(ID,idApp) & idSI(A,ID))
  ).

:- dec_p_type(notDupSysApp(system)).
notDupSysApp(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

  foreach([S1 in SS,S2 in SS],[ID1,ID2],dec([S1,S2],sysImgApp) &
    (ID1 = ID2 implies S1 = S2),
    dec([ID1,ID2],idApp) & idSI(S1,ID1) & idSI(S2,ID2)
  ).

:- dec_p_type(n_notDupSysApp(system)).
n_notDupSysApp(S) :-
  environment(S,E) & dec(E,environment) &
  systemImage(E,SS) & dec(SS,set(sysImgApp)) &

neg(
  foreach([S1 in SS,S2 in SS],[ID1,ID2],dec([S1,S2],sysImgApp) &
    (ID1 = ID2 implies S1 = S2),
    dec([ID1,ID2],idApp) & idSI(S1,ID1) & idSI(S2,ID2)
  )).

:- dec_p_type(allMapsCorrect1(system)).
allMapsCorrect1(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &

  pfun(MM).

:- dec_p_type(n_allMapsCorrect1(system)).
n_allMapsCorrect1(S) :-
  environment(S,E) & dec(E,environment) &
  manifest(E,MM) & dec(MM,manifest_t) &

  neg(pfun(MM)).

:- dec_p_type(allMapsCorrect2(system)).
allMapsCorrect2(S) :-
  environment(S,E) & dec(E,environment) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &

  pfun(CR).

:- dec_p_type(n_allMapsCorrect2(system)).
n_allMapsCorrect2(S) :-
  environment(S,E) & dec(E,environment) &
  cert(E,CR) & dec(CR,rel(idApp,cert)) &

  neg(pfun(CR)).

:- dec_p_type(allMapsCorrect3(system)).
allMapsCorrect3(S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,PR) & dec(PR,rel(idApp,set(perm))) &

  pfun(PR).

:- dec_p_type(n_allMapsCorrect3(system)).
n_allMapsCorrect3(S) :-
  environment(S,E) & dec(E,environment) &
  defPerms(E,PR) & dec(PR,rel(idApp,set(perm))) &

  neg(pfun(PR)).

:- dec_p_type(allMapsCorrect4(system)).
allMapsCorrect4(S) :-
  state(S,St) & dec(St,state) &
  grantedPermGroups(St,GR) & dec(GR,rel(idApp,set(idGrp))) &

  pfun(GR).

:- dec_p_type(n_allMapsCorrect4(system)).
n_allMapsCorrect4(S) :-
  state(S,St) & dec(St,state) &
  grantedPermGroups(St,GR) & dec(GR,rel(idApp,set(idGrp))) &

  neg(pfun(GR)).

:- dec_p_type(allMapsCorrect5(system)).
allMapsCorrect5(S) :-
  state(S,St) & dec(St,state) &
  perms(St,PR) & dec(PR,rel(idApp,set(perm))) &

  pfun(PR).

:- dec_p_type(n_allMapsCorrect5(system)).
n_allMapsCorrect5(S) :-
  state(S,St) & dec(St,state) &
  perms(St,PR) & dec(PR,rel(idApp,set(perm))) &

  neg(pfun(PR)).

:- dec_p_type(allMapsCorrect6(system)).
allMapsCorrect6(S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  pfun(RR).

:- dec_p_type(n_allMapsCorrect6(system)).
n_allMapsCorrect6(S) :-
  state(S,St) & dec(St,state) &
  running(St,RR) & dec(RR,rel(iCmp,cmp)) &

  neg(pfun(RR)).

:- dec_p_type(allMapsCorrect7(system)).
allMapsCorrect7(S) :-
  state(S,St) & dec(St,state) &
  delPPerms(St,PR) & dec(PR,rel([idApp,cProvider,uri],pType)) &

  pfun(PR).

:- dec_p_type(n_allMapsCorrect7(system)).
n_allMapsCorrect7(S) :-
  state(S,St) & dec(St,state) &
  delPPerms(St,PR) & dec(PR,rel([idApp,cProvider,uri],pType)) &

  neg(pfun(PR)).

:- dec_p_type(allMapsCorrect8(system)).
allMapsCorrect8(S) :-
  state(S,St) & dec(St,state) &
  delTPerms(St,TR) & dec(TR,rel([iCmp,cProvider,uri],pType)) &

  pfun(TR).

:- dec_p_type(n_allMapsCorrect8(system)).
n_allMapsCorrect8(S) :-
  state(S,St) & dec(St,state) &
  delTPerms(St,TR) & dec(TR,rel([iCmp,cProvider,uri],pType)) &

  neg(pfun(TR)).

:- dec_p_type(allMapsCorrect9(system)).
allMapsCorrect9(S) :-
  state(S,St) & dec(St,state) &
  resCont(St,RR) & dec(RR,rel([idApp,res],val)) &

  pfun(RR).

:- dec_p_type(n_allMapsCorrect9(system)).
n_allMapsCorrect9(S) :-
  state(S,St) & dec(St,state) &
  resCont(St,RR) & dec(RR,rel([idApp,res],val)) &

  neg(pfun(RR)).

:- dec_p_type(noDupSentIntents(system)).
noDupSentIntents(S) :-
  state(S,St) & dec(St,state) &
  sentIntents(St,SSS) & dec(SSS,set([iCmp,intent])) &

  foreach([[IC1,I1] in SSS,[IC2,I2] in SSS],[ID1,ID2],
      dec([IC1,IC2],iCmp) & dec([I1,I2],intent) &
    (ID1 = ID2 implies IC1 = IC2 & I1 = I2),
    dec([ID1,ID2],idInt) & idI(I1,ID1) & idI(I2,ID2)
  ).

:- dec_p_type(n_noDupSentIntents(system)).
n_noDupSentIntents(S) :-
  state(S,St) & dec(St,state) &
  sentIntents(St,SSS) & dec(SSS,set([iCmp,intent])) &

neg(
  foreach([[IC1,I1] in SSS,[IC2,I2] in SSS],[ID1,ID2],
      dec([IC1,IC2],iCmp) & dec([I1,I2],intent) &
    (ID1 = ID2 implies IC1 = IC2 & I1 = I2),
    dec([ID1,ID2],idInt) & idI(I1,ID1) & idI(I2,ID2)
  )).

:- dec_p_type(validstate(set(perm),system)).
validstate(SystemPerm,S) :-
  allCmpDifferent1(S) &
  allCmpDifferent2(S) &
  allCmpDifferent3(S) &
  allCmpDifferent4(S) &
  allCmpDifferent5(S) &
  notRepeatedCmps1(S) &
  notRepeatedCmps2(S) &
  notRepeatedCmps3(S) &
  notCPrunning(S) &
  delTmpRun(S) &
  cmpRunAppIns(S) &
  resContAppInst(S) &
  statesConsistency1(S) &
  statesConsistency2(S) &
  statesConsistency3(S) &
  statesConsistency41(S) &
  statesConsistency42(S) &
  statesConsistency43(S) &
  statesConsistency51(S) &
  statesConsistency52(S) &
  statesConsistency53(S) &
  notDupApp(S) &
  notDupSysApp(S) &
  notDupPerm1(S) &
  notDupPerm2(S) &
  notDupPerm3(S) &
  allMapsCorrect1(S) &
  allMapsCorrect2(S) &
  allMapsCorrect3(S) &
  allMapsCorrect4(S) &
  allMapsCorrect5(S) &
  allMapsCorrect6(S) &
  allMapsCorrect7(S) &
  allMapsCorrect8(S) &
  allMapsCorrect9(S) &
  grantedPermsExist(SystemPerm,S) &
  noDupSentIntents(S).















