:- prolog_call(b_getval(type_check,on)) &
   dec_type(intentAction,enum([activityAction,serviceAction,broadcastAction])) &
   dec_type(intentFilter,
            [set(intentAction), % actFilter
             set(data),         % dataFilter
             set(category)      % catFilter
            ]) &
   dec_type(activity,
            [idCmp,            % idA
             optb,             % expA
             optp,             % cmpEA
             set(intentFilter) % intFilterA
            ]) &
   dec_type(service,
            [idCmp,            % idS
             optb,             % expS
             optp,             % cmpES
             set(intentFilter) % intFilterS
            ]) &
   dec_type(broadReceiver,
            [idCmp,            % idB
             optb,             % expB
             optp,             % cmpEB
             set(intentFilter) % intFilterB
            ]) &
   dec_type(cmp,
       sum([cmpAct(activity),
            cmpSrv(service),cmpCP(cProvider),cmpBR(broadReceiver)])) &
   dec_type(optn,sum([nulln,num(int)])) &
   dec_type(permLevel,enum([dangerous,normal,signature,signatureOrSys])) &
   dec_type(optg,sum([nullg,grp(idGrp)])) &
   dec_type(perm,
            [idPerm,   % idP
             optg,     % maybeGrp
             permLevel % pl
            ]) &
   dec_type(optp,sum([nullp,permc(perm)])) &
   dec_type(manifest,
            [set(cmp),  % cmp
             optn,      % minSdk
             optn,      % targetSdk
             set(perm), % use
             set(perm), % usrP
             optp       % appE
            ]) &
   dec_type(sysImgApp,
            [idApp,     % idSI
             cert,      % certSI
             manifest,  % manifestSI
             set(perm), % defPermsSI
             set(res)   % appResSI
            ]) &
   dec_type(manifest_t,rel(idApp,manifest)) &
   dec_type(environment,
            [manifest_t,  % manifest
             rel(idApp,cert),      % cert
             rel(idApp,set(perm)), % defPerms
             set(sysImgApp)        % systemImage
            ]) &
   dec_type(bool,enum([true,false])) &
   dec_type(optb,sum([nullb,boolc(bool)])) &
   dec_type(cProvider,
            [idCmp,        % idC
             rel(uri,res), % map_res
             optb,         % expC
             optp,         % cmpEC
             optp,         % readE
             optp,         % writeE
             bool,         % grantU
             set(uri)      % uriP
            ]) &
   dec_type(pType,enum([read,write,both])) &
   dec_type(opti,sum([nulli,idcmp(idCmp)])) &
   dec_type(intentType,enum([intActivity,intService,intBroadcast])) &
   dec_type(opta,sum([nulla,act(intentAction)])) &
   dec_type(optu,sum([nullu,uric(uri)])) &
   dec_type(optm,sum([nullm,mt(mimeType)])) &
   dec_type(dataType,enum([content,file,other])) &
   dec_type(data,
            [optu,    % path
             optm,    % mime
             dataType % type
            ]) &
   dec_type(opte,sum([nulle,ex(extra)])) &
   dec_type(optf,sum([nullf,fl(flag)])) &
   dec_type(intent,
            [idInt,         % idI
             opti,          % cmpName
             intentType,    % intType
             opta,          % action
             data,          % data
             set(category), % category
             opte,          % extra
             optf,          % flags
             optp           % brperm
            ]) &
   dec_type(state,
            [set(idApp),                       % apps
             set(idApp),                       % alreadyVerified
             rel(idApp,set(idGrp)),            % grantedPermGroups
             rel(idApp,set(perm)),             % perms
             rel(iCmp,cmp),                    % running
             rel([idApp,cProvider,uri],pType), % delPPerms
             rel([iCmp,cProvider,uri],pType),  % delTPerms
             rel([idApp,res],val),             % resCont
             set([iCmp,intent])                % sentIntents
            ]) &
   dec_type(system,[state,environment])
   or
   true.

